// Package wrapper ...
//
// Description : wrapper ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2023-05-05 14:44
package wrapper

const (
	DataTypeAny = "interface"

	DataTypeString = "string"

	DataTypeInt8  = "int8"
	DataTypeInt16 = "int16"
	DataTypeInt32 = "int32"
	DataTypeInt64 = "int64"
	DataTypeInt   = "int"

	DataTypeUint8  = "uint8"
	DataTypeUint16 = "uint16"
	DataTypeUint32 = "uint32"
	DataTypeUint64 = "uint64"
	DataTypeUint   = "uint"

	DataTypeBool = "bool"

	DataTypeNumber = "number"

	DataTypeFloat32 = "float32"
	DataTypeFloat64 = "float64"
	DataTypeDouble  = "double"
	DataTypeFloat   = "float"

	DataTypeIntSlice    = "[]int"
	DataTypeUntSlice    = "[]uint"
	DataTypeNumberSlice = "[]number"
	DataTypeFloatSlice  = "[]float"
	DataTypeBoolSlice   = "[]bool"
	DataTypeAnySlice    = "[]interface"

	DataTypeObject    = "map[string]interface"
	DataTypeAnyObject = "map[interface]interface"
)

// Int8Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:25 2023/5/8
type Int8Result struct {
	Value int8
	Err   error
}

// Int16Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:26 2023/5/8
type Int16Result struct {
	Value int16
	Err   error
}

// Int32Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:26 2023/5/8
type Int32Result struct {
	Value int32
	Err   error
}

// Int64Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:26 2023/5/8
type Int64Result struct {
	Value int64
	Err   error
}

// IntResult ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:26 2023/5/8
type IntResult struct {
	Value int
	Err   error
}

// Uint8Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:28 2023/5/8
type Uint8Result struct {
	Value uint8
	Err   error
}

// Uint16Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:28 2023/5/8
type Uint16Result struct {
	Value uint16
	Err   error
}

// Uint32Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:28 2023/5/8
type Uint32Result struct {
	Value uint32
	Err   error
}

// Uint64Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:28 2023/5/8
type Uint64Result struct {
	Value uint64
	Err   error
}

// UintResult ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:29 2023/5/8
type UintResult struct {
	Value uint
	Err   error
}

// Float32Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:31 2023/5/8
type Float32Result struct {
	Value float32
	Err   error
}

// Float64Result ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:32 2023/5/8
type Float64Result struct {
	Value float64
	Err   error
}

// Any ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:40 2023/5/8
type Any struct {
	Value interface{}
	Err   error
}

// BoolResult ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:36 2023/5/8
type BoolResult struct {
	Value bool
	Err   error
}

// ObjectResult ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:38 2023/5/8
type ObjectResult struct {
	Value map[string]interface{}
	Err   error
}

// StringResult ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 16:57 2023/5/8
type StringResult struct {
	Value string
	Err   error
}
